;======================================================
; Lemmy's Circus Ball
; By Erik557
;======================================================
; Description: A ball that will make Mario bounce if he
; collides with it.
; Uses first extra bit: NO
;======================================================

Tilemap:
       db $4A,$4C,$4A,$4C
YSpeeds:
       db $A0,$D0,$C0,$D0
BounceSpeed:
       db $40,$C0

;=================================
; INIT and MAIN Wrappers
;=================================

print "MAIN ",pc
       PHB
       PHK
       PLB
       JSR CircusBall
       PLB
print "INIT ",pc
       RTL

;========================
; Main routine
;========================

CircusBall:
       JSL $0190B2
       LDY $15EA,x
       LDA $14
       LSR #2
       AND #$03
       TAX
       LDA Tilemap,x
       STA $0302,y
       LDX $15E9
       LDA $15F6,x
       ORA $64
       STA $0303,y
       LDA $9D
       BNE .Return
       JSL $01802A
       LDA $1588,x
       AND #$04
       BEQ .Interact
       JSL $01ACF9
       AND #$03
       TAY
       LDA YSpeeds,y
       STA $AA,x
.Interact
       JSL $01A7DC
       BCC .Return
       LDA $0E
       CMP #$EB
       BPL .TouchingSide
       LDA $7D
       BMI .TouchingSide
       LDA #$B8
       STA $7D
       LDA #$08
       STA $1DFC
.Return
       RTS
.TouchingSide
       JSR SubHorizPos
       LDA BounceSpeed,y
       STA $7B
       LDA #$08
       STA $1DFC
       RTS

;==================
  SubHorizPos:
;==================

       LDY #$00
       LDA $94
       SEC
       SBC $E4,x
       STA $0F
       LDA $95
       SBC $14E0,x
       BPL $01
       INY
       RTS
